Attribute VB_Name = "modMF"
' Autor: F. Schler (frank@activevb.de)
' Datum: 08/2021

Option Explicit

' ----==== Const ====----
Public Const VT_EMPTY As Integer = 0

Public Const S_OK As Long = &H0&
Public Const API_TRUE As Long = &H1&
Public Const API_FALSE As Long = &H0&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&
Public Const DIB_RGB_COLORS As Long = &H0&

Public Const MF_VERSION As Long = &H1&
Public Const MF_STARTUP_FULL As Long = &H0&

Public Const GUID_NULL As String = "{00000000-0000-0000-0000-000000000000}"

Public Const MR_POLICY_VOLUME_SERVICE  As String = "{1abaa2ac-9d3b-47c6-ab48-c59506de784d}"
Public Const IID_IMFSimpleAudioVolume As String = "{089edf13-cf71-4338-8d13-9e569dbdc319}"

Public Const MR_STREAM_VOLUME_SERVICE As String = "{f8b5fa2f-32ef-46f5-b172-1321212fb2c4}"
Public Const IID_IMFAudioStreamVolume As String = "{76b1bbdb-4ec8-4f36-b106-70a9316df593}"

Public Const MR_VIDEO_MIXER_SERVICE As String = "{073cd2fc-6cf4-40b7-8859-e89552c841f8}"
Public Const IID_IMFVideoProcessor As String = "{6ab0000c-fece-4d1f-a2ac-a9573530656e}"
Public Const IID_IMFVideoMixerBitmap As String = "{814c7b20-0fdb-4eec-af8f-f957c8f69edc}"

Public Const MR_VIDEO_RENDER_SERVICE As String = "{1092a86c-ab1a-459a-a336-831fbc4d11ff}"
Public Const IID_IMFVideoDisplayControl As String = "{a490b1e4-ab84-4d31-a1b2-181e03b1077a}"

Public Const IID_IPicture As String = "{7bf80980-bf32-101a-8bbb-00aa00300cab}"
Public Const IID_IMFMediaSource As String = "{279a808d-aec7-40c8-9c6b-a6b492c78a66}"

Public Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00aa00389b71}"
Public Const MFMediaType_Video As String = "{73646976-0000-0010-8000-00aa00389b71}"

Public Const MF_TOPONODE_SOURCE As String = "{835c58ec-e075-4bc7-bcba-4de000df9ae6}"
Public Const MF_TOPONODE_STREAM_DESCRIPTOR As String = "{835c58ee-e075-4bc7-bcba-4de000df9ae6}"
Public Const MF_TOPONODE_PRESENTATION_DESCRIPTOR As String = "{835c58ed-e075-4bc7-bcba-4de000df9ae6}"

Public Const MF_DEVSOURCE_ATTRIBUTE_SOURCE_TYPE As String = "{c60ac5fe-252a-478f-a0ef-bc8fa5f7cad3}"
Public Const MF_DEVSOURCE_ATTRIBUTE_FRIENDLY_NAME As String = "{60d0e559-52f8-4fa2-bbce-acdb34a8ec01}"
Public Const MF_DEVSOURCE_ATTRIBUTE_SOURCE_TYPE_AUDCAP_GUID As String = "{14dd9a1c-7cff-41be-b1b9-ba1ac6ecb571}"
Public Const MF_DEVSOURCE_ATTRIBUTE_SOURCE_TYPE_VIDCAP_GUID As String = "{8ac3587a-4ae7-42d8-99e0-0a6013eef90f}"

' ----==== Enums ====----
Public Enum vtb_Interfaces

    ' IMFAttributes
    SetGUID = 24
    SetUnknown = 27
    SetObject = 33
    
    ' IMFActivate
    GetAllocatedString = 13
    ActivateObject = 33
    
    ' IMFCollection
    AddElement = 5
    
    ' IMFMediaSource
    CreatePresentationDescriptor = 8
    Shutdown_Source = 12
    
    ' IMFMediaSession
    SetTopology = 7
    Start_Play = 9
    Stop_Play = 11
    Close_Session = 12
    Shutdown_Session = 13
    
    ' IMFTopologyNode
    ConnectOutput = 40
    
    ' IMFTopology
    AddNode = 34
    
    ' IMFMediaTypeHandler
    GetMajorType = 8
    
    ' IMFStreamDescriptor
    GetMediaTypeHandler = 34
    
    ' IMFPresentationDescriptor
    GetStreamDescriptorCount = 33
    GetStreamDescriptorByIndex = 34
    
    ' IMFSimpleAudioVolume
    SetMasterVolume = 3
    GetMasterVolume = 4
    SetMute = 5
    GetMute = 6
    
    ' IMFAudioStreamVolume
    GetChannelCount = 3
    SetChannelVolume = 4
    GetChannelVolume = 5
    SetAllVolumes = 6
    GetAllVolumes = 7
    
    ' IMFVideoMixerBitmap
    SetAlphaBitmap = 3
    ClearAlphaBitmap = 4
    UpdateAlphaBitmapParameters = 5
    GetAlphaBitmapParameters = 6
    
    ' IMFVideoProcessor
    GetAvailableVideoProcessorModes = 3
    GetVideoProcessorCaps = 4
    GetVideoProcessorMode = 5
    SetVideoProcessorMode = 6
    GetProcAmpRange = 7
    GetProcAmpValues = 8
    SetProcAmpValues = 9
    GetFilteringRange = 10
    GetFilteringValue = 11
    SetFilteringValue = 12
    GetBackgroundColor = 13
    SetBackgroundColor = 14
    
    ' IMFVideoDisplayControl
    GetNativeVideoSize = 3
    GetIdealVideoSize = 4
    SetVideoPosition = 5
    GetVideoPosition = 6
    SetAspectRatioMode = 7
    GetAspectRatioMode = 8
    SetVideoWindow = 9
    GetVideoWindow = 10
    RepaintVideo = 11
    GetCurrentImage = 12
    SetBorderColor = 13
    GetBorderColor = 14
    SetRenderingPrefs = 15
    GetRenderingPrefs = 16
    SetFullscreen = 17
    GetFullscreen = 18

End Enum

Public Enum MF_TOPOLOGY_TYPE
    MF_TOPOLOGY_OUTPUT_NODE = &H0&
    MF_TOPOLOGY_SOURCESTREAM_NODE = &H1&
    MF_TOPOLOGY_TRANSFORM_NODE = &H2&
    MF_TOPOLOGY_TEE_NODE = &H3&
End Enum

Public Enum MFVideoAlphaBitmapFlags
    MFVideoAlphaBitmap_EntireDDS = &H1&
    MFVideoAlphaBitmap_SrcColorKey = &H2&
    MFVideoAlphaBitmap_SrcRect = &H4&
    MFVideoAlphaBitmap_DestRect = &H8&
    MFVideoAlphaBitmap_FilterMode = &H10&
    MFVideoAlphaBitmap_Alpha = &H20&
    MFVideoAlphaBitmap_BitMask = &H3F&
End Enum

Public Enum D3DTEXTUREFILTERTYPE
    D3DTEXF_NONE = &H0
    D3DTEXF_POINT = &H1
    D3DTEXF_LINEAR = &H2
    D3DTEXF_ANISOTROPIC = &H3
    D3DTEXF_PYRAMIDALQUAD = &H6
    D3DTEXF_GAUSSIANQUAD = &H7
    D3DTEXF_CONVOLUTIONMONO = &H8
End Enum

Public Enum PROCAMPSETTINGS
    DXVA2_ProcAmp_None = &H0&
    DXVA2_ProcAmp_Brightness = &H1&
    DXVA2_ProcAmp_Contrast = &H2&
    DXVA2_ProcAmp_Hue = &H4&
    DXVA2_ProcAmp_Saturation = &H8&
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type SIZE
    cx As Long
    cy As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type BITMAPINFO256
    bmiHeader As BITMAPINFOHEADER
    bmiColors(255) As Long
End Type

Public Type MFVideoNormalizedRect
    Left As Single
    Top As Single
    Right As Single
    Bottom As Single
End Type

Public Type MFVideoAlphaBitmapParams
    dwFlags As MFVideoAlphaBitmapFlags
    clrSrcKey As Long
    rcSrc As RECT
    nrcDest As MFVideoNormalizedRect
    fAlpha As Single
    dwFilterMode As D3DTEXTUREFILTERTYPE
End Type

Public Type MFVideoAlphaBitmap
    GetBitmapFromDC As Long ' Bool
    hDC_pDDS As Long ' hDC oder Pointer auf ein IDirect3DSurface9
    params As MFVideoAlphaBitmapParams
End Type

Public Type DXVA2_Fixed32
    Fraction As Integer ' VB6 kann kein UInteger!
    Value As Integer
End Type

Public Type DXVA2_ValueRange
    MinValue As DXVA2_Fixed32
    MaxValue As DXVA2_Fixed32
    DefaultValue As DXVA2_Fixed32
    StepSize As DXVA2_Fixed32
End Type

Public Type DXVA2_ProcAmpValues
    Brightness As DXVA2_Fixed32
    Contrast As DXVA2_Fixed32
    Hue As DXVA2_Fixed32
    Saturation As DXVA2_Fixed32
End Type

' ----==== Gdi32.dll Deklarationen ====----
Public Declare Function CreateDIBSection256 Lib "Gdi32.dll" _
                        Alias "CreateDIBSection" ( _
                        ByVal hdc As Long, _
                        ByRef pBitmapInfo As BITMAPINFO256, _
                        ByVal un As Long, _
                        ByVal lplpVoid As Long, _
                        ByVal handle As Long, _
                        ByVal dw As Long) As Long
                        
Public Declare Function SetDIBits256 Lib "Gdi32.dll" _
                        Alias "SetDIBits" ( _
                        ByVal hdc As Long, _
                        ByVal hBitmap As Long, _
                        ByVal nStartScan As Long, _
                        ByVal nNumScans As Long, _
                        ByVal lpBits As Long, _
                        ByRef lpBI As BITMAPINFO256, _
                        ByVal wUsage As Long) As Long
                        
Public Declare Function DeleteObject Lib "Gdi32.dll" ( _
                        ByVal hObject As Long) As Long
                        
' ----==== Ole32.dll Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)
                   
Public Declare Function CLSIDFromString Lib "ole32.dll" ( _
                        ByVal pstring As Long, _
                        ByRef pCLSID As GUID) As Long

Public Declare Function StringFromGUID Lib "ole32.dll" _
                        Alias "StringFromIID" ( _
                        ByRef pCLSID As GUID, _
                        ByRef lpszProgID As Long) As Long

' ----==== OleAut32.dll Deklarationen ====----
Public Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                        ByVal pvInstance As Long, _
                        ByVal oVft As Long, _
                        ByVal cc As Long, _
                        ByVal vtReturn As VbVarType, _
                        ByVal cActuals As Long, _
                        ByVal prgvt As Any, _
                        ByVal prgpvarg As Any, _
                        ByRef pvargResult As Variant) As Long
                        
Public Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                        ByRef lpPictDesc As PICTDESC, _
                        ByRef riid As GUID, _
                        ByVal fOwn As Long, _
                        ByRef lplpvObj As Object) As Long
                         
' ----==== Kernel32.dll Deklarationen ====----
Public Declare Sub Sleep Lib "Kernel32.dll" ( _
                   ByVal lngMilliseconds As Long)

Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Public Declare Function lstrlenW Lib "Kernel32.dll" ( _
                        ByVal lpString As Long) As Long

' ----==== User32.dll Deklarationen ====----
Public Declare Function GetDC Lib "User32.dll" ( _
                        ByVal hwnd As Long) As Long
                         
Public Declare Function ReleaseDC Lib "User32.dll" ( _
                        ByVal hwnd As Long, _
                        ByVal hdc As Long) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateAttributes Lib "Mfplat.dll" ( _
                        ByRef ppMFAttributes As Long, _
                        ByVal cInitialSize As Long) As Long

Public Declare Function MFCreateCollection Lib "Mfplat.dll" ( _
                        ByRef ppIMFCollection As Long) As Long

' ----==== Mf.dll Deklarationen ====----
Public Declare Function MFEnumDeviceSources Lib "Mf.dll" ( _
                        ByVal pAttributes As Long, _
                        ByRef pppSourceActivate As Long, _
                        ByRef pcSourceActivate As Long) As Long

Public Declare Function MFCreateAggregateSource Lib "Mf.dll" ( _
                        ByVal pSourceCollection As Long, _
                        ByRef ppAggSource As Long) As Long

Public Declare Function MFCreateMediaSession Lib "Mf.dll" ( _
                        ByVal pConfiguration As Long, _
                        ByRef ppMediaSession As Long) As Long

Public Declare Function MFCreateTopology Lib "Mf.dll" ( _
                        ByRef ppTopo As Long) As Long

Public Declare Function MFCreateTopologyNode Lib "Mf.dll" ( _
                        ByVal NodeType As MF_TOPOLOGY_TYPE, _
                        ByRef ppNode As Long) As Long

Public Declare Function MFCreateAudioRendererActivate Lib "Mf.dll" ( _
                        ByRef ppActivate As Long) As Long

Public Declare Function MFCreateVideoRendererActivate Lib "Mf.dll" ( _
                        ByVal hwndVideo As Long, _
                        ByRef ppActivate As Long) As Long
                        
Public Declare Function MFGetService Lib "Mf.dll" ( _
                        ByVal punkObject As Long, _
                        ByVal guidService As Long, _
                        ByVal riid As Long, _
                        ByRef ppvObject As Long) As Long

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim varRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, varRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, _
    ParamArray varParam()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, varParam)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lngRet As Long
    Dim lngItem As Long
    Dim lngCount As Long
    Dim varRet As Variant
    Dim varParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            varParam = aParam

            ' ist der Variant ein Array
            If IsArray(varParam) Then varParam = varParam(0)

            ' Anzahl der Parameter
            lngCount = UBound(varParam)

            ' alle Parameter durchlaufen
            For lngItem = 0 To lngCount

                ' Typ des Parameter
                oleTyp(lngItem) = VarType(varParam(lngItem))

                ' Pointer auf den Parameter
                olePtr(lngItem) = VarPtr(varParam(lngItem))

            Next lngItem

        End If

        ' Funktion des Interfaces aufrufen
        lngRet = DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lngItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), varRet)
            
        If lngRet <> S_OK Then
            
            Debug.Print "DispCallFunc Error: 0x" & Hex$(lngRet)
            
        Else
            
            If varRet <> S_OK Then
        
                Debug.Print "COM Error: 0x" & Hex$(varRet)
            
            End If

        End If

    End If

    OleInvoke = varRet

End Function

' ----==== GUID-String to Structure GUID ====----
Public Function Str2Guid(ByVal sGUID As String) As GUID

    If Len(sGUID) = 38& Then

        Call CLSIDFromString(StrPtr(sGUID), Str2Guid)
    
    End If
    
End Function

' ----==== Structure GUID to GUID-String ====----
Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim pGUID As Long

    If StringFromGUID(tGUID, pGUID) = S_OK Then

        Guid2Str = Ptr2Str(pGUID)
    
    End If

End Function

' ----==== String-Pointer to String ====----
Public Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lngStrLen As Long
    Dim bytBuffer() As Byte
    
    If lpStrPointer <> 0& Then
    
        lngStrLen = lstrlenW(lpStrPointer) * 2
        
        If lngStrLen > 0 Then
        
            ReDim bytBuffer(lngStrLen - 1)
            
            Call CopyMemory(bytBuffer(0), ByVal lpStrPointer, lngStrLen)
            
            Call CoTaskMemFree(lpStrPointer)
            
            Ptr2Str = CStr(bytBuffer)
            
        End If
        
    End If
    
End Function

' ----==== Wait ====----
Public Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Call Sleep(1)

        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400

        PrevTimer = Timer

    Loop

End Sub

' ----==== DIP-Pointer to Bitmap-File ====----
Public Function SaveCurrentPicture(ByVal pDib As Long, _
    ByRef tBIH As BITMAPINFOHEADER, _
    ByRef sBmpFilePath As String) As Boolean
    
    Dim bolRet As Boolean
    Dim lngDC As Long
    Dim hBmp As Long
    Dim oPicture As IPicture
    Dim tPictDesc As PICTDESC
    Dim tBITMAPINFO As BITMAPINFO256
    
    bolRet = False
    
    ' DC ermitteln
    lngDC = GetDC(0&)
    
    ' ist ein DC vorhanden
    If lngDC <> 0& Then
    
        tBITMAPINFO.bmiHeader = tBIH
        
        ' DIB-Bitmap erstellen
        hBmp = CreateDIBSection256(lngDC, tBITMAPINFO, _
            DIB_RGB_COLORS, 0&, 0&, 0&)
            
        ' ist ein DIB-Bitmap vorhanden
        If hBmp <> 0& Then
        
            ' Bitmapdaten in das DIB-Bitmap schreiben
            If SetDIBits256(lngDC, hBmp, 0&, tBIH.biHeight, pDib, _
                tBITMAPINFO, DIB_RGB_COLORS) <> 0& Then
                
                ' Parameter setzen
                With tPictDesc
                    .cbSizeOfStruct = Len(tPictDesc)
                    .picType = vbPicTypeBitmap
                    .hgdiObj = hBmp
                    .hPalOrXYExt = 0&
                End With
                
                ' IPicture erstellen
                If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                    API_TRUE, oPicture) = S_OK Then
                    
                    ' Backslash anfgen falls nicht vorhanden
                    If Right(sBmpFilePath, 1) <> "\" Then sBmpFilePath = sBmpFilePath & "\"
                    
                    ' Pfad zusammenbauen
                    sBmpFilePath = sBmpFilePath & "image_" & Format$(Now, "yyyyMMddhhmmss") & ".bmp"
                    
                    ' existiert die Datei bereits?
                    If FileExists(sBmpFilePath) = True Then
                    
                        ' vorhandene Datei lschen
                        Call Kill(sBmpFilePath)
                        
                    End If
    
                    ' IPicture speichern
                    Call SavePicture(oPicture, sBmpFilePath)
                    
                    ' existiert die Datei?
                    If FileExists(sBmpFilePath) = True Then
                    
                        ' alles OK
                        bolRet = True
                        
                    End If
                    
                    ' IPicture lschen
                    Set oPicture = Nothing
    
                End If
                
            End If
            
            ' hBmp lschen
            Call DeleteObject(hBmp)
            
        End If
        
        ' DC freigeben
        Call ReleaseDC(0&, lngDC)
        
    End If
    
    SaveCurrentPicture = bolRet
    
End Function

' ----==== FileExists ====----
Public Function FileExists(ByVal sFileName As String) As Boolean

    On Error Resume Next
    
    Dim lngRet As Long
    
    lngRet = Len(Dir$(sFileName))
    
    If Err Or lngRet = 0 Then FileExists = False Else FileExists = True
    
End Function

' ----==== Structure DXVA2_Fixed32 to Single ====----
Public Function DXVA2FixedToFloat(ByRef tFixed32 As DXVA2_Fixed32) As Single

    DXVA2FixedToFloat = CSng(tFixed32.Value) + CSng(tFixed32.Fraction) / &H10000

End Function

' ----==== Single to Structure DXVA2_Fixed32 ====----
Public Function DXVA2FloatToFixed(ByVal sngFloat As Single) As DXVA2_Fixed32

    Dim tDXVA2_Fixed32 As DXVA2_Fixed32
    
    tDXVA2_Fixed32.Fraction = LoWord(sngFloat * &H10000)
    tDXVA2_Fixed32.Value = HiWord(sngFloat * &H10000)
    
    DXVA2FloatToFixed = tDXVA2_Fixed32

End Function

' ----==== LoWord ====----
Public Function LoWord(ByVal DWord As Long) As Integer

    Call CopyMemory(LoWord, ByVal VarPtr(DWord), 2)
    
End Function

' ----==== HiWord ====----
Public Function HiWord(ByVal DWord As Long) As Integer

    Call CopyMemory(HiWord, ByVal VarPtr(DWord) + 2, 2)
    
End Function
